// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package autogenerated

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// SubmitServiceClient is the client API for SubmitService service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type SubmitServiceClient interface {
	GetNonce(ctx context.Context, in *SubmitRequest, opts ...grpc.CallOption) (*SubmitResponse, error)
}

type submitServiceClient struct {
	cc grpc.ClientConnInterface
}

func NewSubmitServiceClient(cc grpc.ClientConnInterface) SubmitServiceClient {
	return &submitServiceClient{cc}
}

func (c *submitServiceClient) GetNonce(ctx context.Context, in *SubmitRequest, opts ...grpc.CallOption) (*SubmitResponse, error) {
	out := new(SubmitResponse)
	err := c.cc.Invoke(ctx, "/autogenerated.SubmitService/GetNonce", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// SubmitServiceServer is the server API for SubmitService service.
// All implementations must embed UnimplementedSubmitServiceServer
// for forward compatibility
type SubmitServiceServer interface {
	GetNonce(context.Context, *SubmitRequest) (*SubmitResponse, error)
	mustEmbedUnimplementedSubmitServiceServer()
}

// UnimplementedSubmitServiceServer must be embedded to have forward compatible implementations.
type UnimplementedSubmitServiceServer struct {
}

func (UnimplementedSubmitServiceServer) GetNonce(context.Context, *SubmitRequest) (*SubmitResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetNonce not implemented")
}
func (UnimplementedSubmitServiceServer) mustEmbedUnimplementedSubmitServiceServer() {}

// UnsafeSubmitServiceServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to SubmitServiceServer will
// result in compilation errors.
type UnsafeSubmitServiceServer interface {
	mustEmbedUnimplementedSubmitServiceServer()
}

func RegisterSubmitServiceServer(s grpc.ServiceRegistrar, srv SubmitServiceServer) {
	s.RegisterService(&SubmitService_ServiceDesc, srv)
}

func _SubmitService_GetNonce_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(SubmitRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(SubmitServiceServer).GetNonce(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/autogenerated.SubmitService/GetNonce",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(SubmitServiceServer).GetNonce(ctx, req.(*SubmitRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// SubmitService_ServiceDesc is the grpc.ServiceDesc for SubmitService service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var SubmitService_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "autogenerated.SubmitService",
	HandlerType: (*SubmitServiceServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "GetNonce",
			Handler:    _SubmitService_GetNonce_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "pkg/autogenerated/submit.proto",
}
